"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

class exampleimu_t(object):
    __slots__ = ["yaw", "pitch", "roll", "mag_x", "mag_y", "mag_z", "acc_x", "acc_y", "acc_z", "gyro_x", "gyro_y", "gyro_z"]

    def __init__(self):
        self.yaw = 0.0
        self.pitch = 0.0
        self.roll = 0.0
        self.mag_x = 0.0
        self.mag_y = 0.0
        self.mag_z = 0.0
        self.acc_x = 0.0
        self.acc_y = 0.0
        self.acc_z = 0.0
        self.gyro_x = 0.0
        self.gyro_y = 0.0
        self.gyro_z = 0.0

    def encode(self):
        buf = BytesIO()
        buf.write(exampleimu_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">dddddddddddd", self.yaw, self.pitch, self.roll, self.mag_x, self.mag_y, self.mag_z, self.acc_x, self.acc_y, self.acc_z, self.gyro_x, self.gyro_y, self.gyro_z))

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != exampleimu_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return exampleimu_t._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = exampleimu_t()
        self.yaw, self.pitch, self.roll, self.mag_x, self.mag_y, self.mag_z, self.acc_x, self.acc_y, self.acc_z, self.gyro_x, self.gyro_y, self.gyro_z = struct.unpack(">dddddddddddd", buf.read(96))
        return self
    _decode_one = staticmethod(_decode_one)

    _hash = None
    def _get_hash_recursive(parents):
        if exampleimu_t in parents: return 0
        tmphash = (0x3c1518c4424eca7b) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if exampleimu_t._packed_fingerprint is None:
            exampleimu_t._packed_fingerprint = struct.pack(">Q", exampleimu_t._get_hash_recursive([]))
        return exampleimu_t._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

